/*
FILE
	$Id: mysqlrad.h 30 2006-08-23 18:46:52Z hus $
	ism|3 mysqlRAD2 generated include file for mysqlBind.cgi
	(tAuthorize.cPasswd template set member)
AUTHOR
	Template and mysqlRAD2 author: (c) 2001,2002 Gary Wallis. 
	GPL license applies: See www.fsf.org
LEGAL
	(C) 2001-2004 Gary Wallis. See LICENSE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
//This is an example tune for your system
#ifndef Linux
        #include <sys/systeminfo.h>
#else
        #ifndef FreeBSD
                #include <crypt.h>
        #endif
#endif
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <sys/file.h>

#include "cgi.h"

//This is an example tune for your system
#ifdef FreeBSD
	#include "/usr/local/include/mysql/mysql.h"
#else
	#include <mysql/mysql.h>
#endif


#include <unistd.h>

#include "language.h"
#include "local.h"

extern char cHost[];
extern char cHostname[];
extern char cUser[];
#define PERMLEVEL
extern int uPermLevel; 
extern unsigned uLoginClient; 
extern unsigned uReseller; 

extern char function[];
extern char query[];
extern char *qstr;
extern MYSQL mysql; 
extern unsigned long rowid;
extern unsigned start;
extern unsigned end;
extern unsigned i;
extern unsigned n;
extern char command[];
extern char filter[];
extern char find[];
extern char table[];
extern int mode;
extern int error;
extern char errormsg[];

#ifdef USECONF
extern char gcDbIp[];
extern char *gcEffectiveDbIp;
extern char gcDbName[];
extern char gcDbLogin[];
extern char gcDbPasswd[];
extern unsigned guDbPort;
extern char gcDbSocket[];
extern char *gcEffectiveDbSocket;
void ReadAndSetConfFileGlobalVars(void);
#endif


void mysqlBind(const char *result);
void ConnectDb(void);
void Footer_ism3(void);
void Header_ism3(char *msg, int js);
void ProcessControlVars(pentry entries[], int x);
void OpenRow(char *cFieldLabel, char *cColor);
void OpenFieldSet(char *cLabel, unsigned uWidth);
void CloseFieldSet(void);
void LoadConf(void);
void NoSuchFunction(void);
void tTablePullDownOwner(char *cTableName, char *cFieldName,
                        char *cOrderby, int unsigned uSelector);
void tTablePullDown(char *cTableName, char *cFieldName,
                        char *cOrderby, int unsigned uSelector);
void tTablePullDownReadOnly(char *cTableName, char *cFieldName,
                        char *cOrderby, int unsigned uSelector);
int ReadPullDown(char *cTableName,char *cFieldName,char *cLabel);
const char *TextAreaSave(const char *cField);
const char *TransformAngleBrackets(const char *cField);
const char *EncodeDoubleQuotes(const char *cField);
void YesNoPullDown(char *cFieldName, unsigned uSelect);
void YesNo(unsigned uSelect);
int ReadYesNoPullDown(char *cLabel);
const char *ForeignKey(const char *cTableName, const char *cFieldName, unsigned uKey);
void GetClientOwner(unsigned uClient, unsigned *uOwner);

 //Standard tInputFunc functions
char *WordToLower(char *cInput);
char *IPNumber(char *cInput);
char *FQDomainName(char *cInput);
char *EmailInput(char *cInput);

 //Standard tValidFunc functions
char *EmptyString(char *cInput);
char *BadIPNum(char *cInput);
char *IsZero(unsigned uInput);

 //External pagination form processing vars
void PageMachine(char *funcName, int mode, char *msg);

#define ISPNAME "OpenISP"

 //MakeTableSource prototypes
//tZone
int tZoneCommands(pentry entries[], int x);
void tZone(const char *results);
void ProcesstZoneVars(pentry entries[], int x);
void tZoneInput(unsigned uMode);
void tZoneList(void);
void NewtZone(unsigned uMode);
void ModtZone(void);
void CreatetZone(void);
void DeletetZone(void);
void ExttZoneGetHook(entry gentries[], int x);

//tResource
int tResourceCommands(pentry entries[], int x);
void tResource(const char *results);
void ProcesstResourceVars(pentry entries[], int x);
void tResourceInput(unsigned uMode);
void tResourceList(void);
void NewtResource(unsigned uMode);
void ModtResource(void);
void CreatetResource(void);
void DeletetResource(void);
void ExttResourceGetHook(entry gentries[], int x);

//tRRType
int tRRTypeCommands(pentry entries[], int x);
void tRRType(const char *results);
void ProcesstRRTypeVars(pentry entries[], int x);
void tRRTypeInput(unsigned uMode);
void tRRTypeList(void);
void NewtRRType(unsigned uMode);
void ModtRRType(void);
void CreatetRRType(void);
void DeletetRRType(void);
void ExttRRTypeGetHook(entry gentries[], int x);
void ExttRRTypeNavBar();

//tJob
int tJobCommands(pentry entries[], int x);
void tJob(const char *results);
void ProcesstJobVars(pentry entries[], int x);
void tJobInput(unsigned uMode);
void tJobList(void);
void NewtJob(unsigned uMode);
void ModtJob(void);
void CreatetJob(void);
void DeletetJob(void);
void ExttJobGetHook(entry gentries[], int x);

//tNameServer
int tNameServerCommands(pentry entries[], int x);
void tNameServer(const char *results);
void ProcesstNameServerVars(pentry entries[], int x);
void tNameServerContent(void);
void tNameServerInput(unsigned uMode);
void tNameServerList(void);
void NewtNameServer(unsigned uMode);
void ModtNameServer(void);
void CreatetNameServer(void);
void DeletetNameServer(void);
void ExttNameServerGetHook(entry gentries[], int x);

//tMailServer
int tMailServerCommands(pentry entries[], int x);
void tMailServer(const char *results);
void ProcesstMailServerVars(pentry entries[], int x);
void tMailServerInput(unsigned uMode);
void tMailServerList(void);
void NewtMailServer(unsigned uMode);
void ModtMailServer(void);
void CreatetMailServer(void);
void DeletetMailServer(void);
void ExttMailServerGetHook(entry gentries[], int x);
void ExttMailServerNavBar(void);

//tConfiguration
int tConfigurationCommands(pentry entries[], int x);
void tConfiguration(const char *results);
void ProcesstConfigurationVars(pentry entries[], int x);
void tConfigurationInput(unsigned uMode);
void tConfigurationList(void);
void NewtConfiguration(unsigned uMode);
void ModtConfiguration(void);
void CreatetConfiguration(void);
void DeletetConfiguration(void);
void ExttConfigurationGetHook(entry gentries[], int x);

//tClient
int tClientCommands(pentry entries[], int x);
void tClient(const char *results);
void ProcesstClientVars(pentry entries[], int x);
void tClientInput(unsigned uMode);
void tClientList(void);
void NewtClient(unsigned uMode);
void ModtClient(void);
void CreatetClient(void);
void DeletetClient(void);
void ExttClientGetHook(entry gentries[], int x);

//tAuthorize
int tAuthorizeCommands(pentry entries[], int x);
void tAuthorize(const char *results);
void ProcesstAuthorizeVars(pentry entries[], int x);
void tAuthorizeInput(unsigned uMode);
void tAuthorizeList(void);
void NewtAuthorize(unsigned uMode);
void ModtAuthorize(void);
void CreatetAuthorize(void);
void DeletetAuthorize(void);
void ExttAuthorizeGetHook(entry gentries[], int x);
void ExttAuthorizeNavBar(void);

