/*
FILE
	$Id: tauthorizefunc.h 27 2006-08-23 17:37:48Z hus $
PURPOSE
	Non-schema dependent tauthorize.c expansion.
AUTHOR
	GPL License applies, see www.fsf.org for details
	See LICENSE file in this distribution
	(C) 2001-2004 Gary Wallis.
 
*/


void tAuthorizeNavList(void);

void EncryptPasswdWithSalt(char *cPasswd,char *cSalt);

void ExtProcesstAuthorizeVars(pentry entries[], int x)
{

	/*
	register int i;
	
	for(i=0;i<x;i++)
	{
	
	}
	*/

}//void ExtProcesstAuthorizeVars(pentry entries[], int x)


void ExttAuthorizeCommands(pentry entries[], int x)
{
	if(!strcmp(function,"tAuthorizeTools"))
	{
		if(!strcmp(command,LANG_NB_NEW))
                {
			if(uPermLevel>=12)
			{
                	        ProcesstAuthorizeVars(entries,x);
				//Check global conditions for new record here
				mode=2000;
				tAuthorize(LANG_NB_CONFIRMNEW);
			}
                }
		else if(!strcmp(command,LANG_NB_CONFIRMNEW))
                {
			if(uPermLevel>=12)
			{
				ProcesstAuthorizeVars(entries,x);
				//Check entries here
				uAuthorize=0;
				uCreatedBy=uLoginClient;
				uOwner=uLoginClient;
				uModBy=0;//Never modified
				NewtAuthorize(1);
			}
		}
		else if(!strcmp(command,LANG_NB_DELETE))
                {
                        ProcesstAuthorizeVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2001;
				tAuthorize(LANG_NB_CONFIRMDEL);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMDEL))
                {
                        ProcesstAuthorizeVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=5;
				DeletetAuthorize();
			}
                }
		else if(!strcmp(command,LANG_NB_MODIFY))
                {
                        ProcesstAuthorizeVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uCertClient==uLoginClient)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2002;
				tAuthorize(LANG_NB_CONFIRMMOD);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMMOD))
                {
                        ProcesstAuthorizeVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uCertClient==uLoginClient)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				if(uPerm>uPermLevel) uPerm=uPermLevel;
				if(uPerm<7 || uPerm>12)
				{
					mode=2002;
					sprintf(query,"uPerm level error:%u",uPerm);
					tAuthorize(query);
				}
				if(strncmp(cPasswd,"..",2))
					EncryptPasswdWithSalt(cPasswd,"..");

				uModBy=uLoginClient;
                        	ModtAuthorize();
			}
                }
	}

}//void ExttAuthorizeCommands(pentry entries[], int x)


void ExttAuthorizeButtons(void)
{
	OpenFieldSet("Aux Panel",100);
	switch(mode)
        {
                case 2000:
			printf("Enter required data<br>");
                        printf(LANG_NBB_CONFIRMNEW);
			printf("<br>\n");
                break;

                case 2001:
                        printf(LANG_NBB_CONFIRMDEL);
			printf("<br>\n");
                break;

                case 2002:
			printf("Review record data<br>");
                        printf(LANG_NBB_CONFIRMMOD);
			printf("<br>\n");
                break;

		default:
			tAuthorizeNavList();
	}

	CloseFieldSet();

}//void ExttAuthorizeButtons(void)


void ExttAuthorizeAuxTable(void)
{

}//void ExttAuthorizeAuxTable(void)


void ExttAuthorizeGetHook(entry gentries[], int x)
{
	register int i;

	for(i=0;i<x;i++)
	{
		if(!strcmp(gentries[i].name,"uAuthorize"))
		{
			sscanf(gentries[i].val,"%u",&uAuthorize);
			mode=6;
		}
	}
	tAuthorize("");

}//void ExttAuthorizeGetHook(entry gentries[], int x)


void ExttAuthorizeSelect(void)
{
        //Set non search query here for tTableName()
	if(uPermLevel>=9)
	sprintf(query,"SELECT %s FROM tAuthorize ORDER BY uAuthorize",
					VAR_LIST_tAuthorize);
	else
	sprintf(query,"SELECT %s FROM tAuthorize WHERE uOwner=%u ORDER BY uAuthorize",
					VAR_LIST_tAuthorize,uLoginClient);

}//void ExttAuthorizeSelect(void)


void ExttAuthorizeSelectRow(void)
{
	if(uPermLevel<10)
                sprintf(query,"SELECT %s FROM tAuthorize,tClient \
                                WHERE tAuthorize.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)\
                                AND tAuthorize.uAuthorize=%u",
                        		VAR_LIST_tAuthorize,
					uLoginClient,uLoginClient,uAuthorize);
	else
                sprintf(query,"SELECT %s FROM tAuthorize WHERE uAuthorize=%u",
			VAR_LIST_tAuthorize,uAuthorize);

}//void ExttAuthorizeSelectRow(void)


void ExttAuthorizeListSelect(void)
{
	char cCat[512];

	if(uPermLevel<10)
		sprintf(query,"SELECT %s FROM tAuthorize,tClient \
		WHERE tAuthorize.uOwner=tClient.uClient \
		AND (tClient.uOwner=%u OR tClient.uClient=%u)",
				VAR_LIST_tAuthorize,
				uLoginClient,
				uLoginClient);
	else
                sprintf(query,"SELECT %s FROM tAuthorize",
				VAR_LIST_tAuthorize);

	//Changes here must be reflected below in ExttAuthorizeListFilter()
        if(!strcmp(filter,"uAuthorize"))
        {
                sscanf(command,"%u",&uAuthorize);
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tAuthorize.uAuthorize=%u ORDER BY uAuthorize",
						uAuthorize);
		strcat(query,cCat);
        }
        else if(1)
        {
                //None NO FILTER
                strcpy(filter,"None");
		strcat(query," ORDER BY uAuthorize");
        }

}//void ExttAuthorizeListSelect(void)


void ExttAuthorizeListFilter(void)
{
        //Filter
        printf("<td align=right >Select ");
        printf("<select name=filter>");
        if(strcmp(filter,"uAuthorize"))
                printf("<option>uAuthorize</option>");
        else
                printf("<option selected>uAuthorize</option>");
        if(strcmp(filter,"None"))
                printf("<option>None</option>");
        else
                printf("<option selected>None</option>");
        printf("</select>");

}//void ExttAuthorizeListFilter(void)


void ExttAuthorizeNavBar(void)
{
	if(uOwner) GetClientOwner(uOwner,&uReseller);

	printf(LANG_NBB_SKIPFIRST);
	printf(LANG_NBB_SKIPBACK);
	printf(LANG_NBB_SEARCH);

	if(uPermLevel>=12)
		printf(LANG_NBB_NEW);

	if( (uPermLevel>=8 && uOwner==uLoginClient)
		|| (uPermLevel>9 && uCertClient==uLoginClient)
		|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_MODIFY);

	if( (uPermLevel>=8 && uOwner==uLoginClient)
		|| (uPermLevel>9 && uOwner!=1)
		|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_DELETE);

	printf(LANG_NBB_LIST);

	printf(LANG_NBB_SKIPNEXT);
	printf(LANG_NBB_SKIPLAST);

}//void ExttAuthorizeNavBar(void)


void tAuthorizeNavList(void)
{
        MYSQL_RES *res;
        MYSQL_ROW field;

	if(uPermLevel<10)
		sprintf(query,"SELECT tAuthorize.uAuthorize,tAuthorize.cLabel FROM tAuthorize,tClient WHERE tAuthorize.uOwner=tClient.uClient AND (tClient.uOwner=%u OR tClient.uClient=%u)",
					uLoginClient,uLoginClient);
	else
	        sprintf(query,"SELECT uAuthorize,cLabel FROM tAuthorize");

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
                printf("%s",mysql_error(&mysql));
                return;
        }

        res=mysql_store_result(&mysql);
	if(mysql_num_rows(res))
	{
        	printf("<p><u>tAuthorizeNavList</u><br>\n");
        	while((field=mysql_fetch_row(res)))
        	{
printf("<a class=darkLink href=mysqlBind.cgi?function=tAuthorize&uAuthorize=%s>%s</a><br>\n",field[0],field[1]);
	        }
	}
        mysql_free_result(res);

}//void tAuthorizeNavList(void)

// vim:tw=78
