/*
FILE
	$Id: tmailserverfunc.h 26 2006-08-23 00:55:47Z hus $
PURPOSE
	Non-schema dependent tmailserver.c expansion.
AUTHOR
	GPL License applies, see www.fsf.org for details
	See LICENSE file in this distribution
	(C) 2001-2004 Gary Wallis.
*/

void tMailServerNavList(void);

void ExtProcesstMailServerVars(pentry entries[], int x)
{

	/*
	register int i;
	
	for(i=0;i<x;i++)
	{
	
	}
	*/

}//void ExtProcesstMailServerVars(pentry entries[], int x)


void ExttMailServerCommands(pentry entries[], int x)
{
	if(!strcmp(function,"tMailServerTools"))
	{
		//ModuleFunctionProcess()

		//Default wizard like two step creation and deletion
		if(!strcmp(command,LANG_NB_NEW))
                {
			if(uPermLevel>=10)
			{
				ProcesstMailServerVars(entries,x);
				//Check global conditions for new record here
				mode=2000;
				tMailServer(LANG_NB_CONFIRMNEW);
			}
                }
		else if(!strcmp(command,LANG_NB_CONFIRMNEW))
                {
			if(uPermLevel>=10)
			{
				ProcesstMailServerVars(entries,x);
				//Check entries here
				uMailServer=0;
				uCreatedBy=uLoginClient;
				uOwner=uLoginClient;
				uModBy=0;//Never modified
				NewtMailServer(0);
			}
		}
		else if(!strcmp(command,LANG_NB_DELETE))
                {
                        ProcesstMailServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=12 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2001;
				tMailServer(LANG_NB_CONFIRMDEL);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMDEL))
                {
                        ProcesstMailServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=12 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=5;
				DeletetMailServer();
			}
                }
		else if(!strcmp(command,LANG_NB_MODIFY))
                {
                        ProcesstMailServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=10 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2002;
				tMailServer(LANG_NB_CONFIRMMOD);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMMOD))
                {
                        ProcesstMailServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=10 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				uModBy=uLoginClient;
				ModtMailServer();
			}
                }
	}

}//void ExttMailServerCommands(pentry entries[], int x)


void ExttMailServerButtons(void)
{
	OpenFieldSet("Aux Panel",100);

	switch(mode)
        {
                case 2000:
			printf("Enter required data<br>");
                        printf(LANG_NBB_CONFIRMNEW);
			printf("<br>\n");
                break;

                case 2001:
                        printf(LANG_NBB_CONFIRMDEL);
			printf("<br>\n");
                break;

                case 2002:
			printf("Review record data<br>");
                        printf(LANG_NBB_CONFIRMMOD);
			printf("<br>\n");
                break;

		default:
			tMailServerNavList();

	}

	CloseFieldSet();
	
}//void ExttMailServerButtons(void)


void ExttMailServerAuxTable(void)
{

}//void ExttMailServerAuxTable(void)


void ExttMailServerGetHook(entry gentries[], int x)
{
	register int i;

	for(i=0;i<x;i++)
	{
		if(!strcmp(gentries[i].name,"uMailServer"))
		{
			sscanf(gentries[i].val,"%u",&uMailServer);
			mode=6;
		}
	}
	tMailServer("");

}//void ExttMailServerGetHook(entry gentries[], int x)


void ExttMailServerSelect(void)
{
        //Set non search query here for tTableName()
	if(uPermLevel>=9)
	sprintf(query,"SELECT %s FROM tMailServer ORDER BY uMailServer",
					VAR_LIST_tMailServer);
	else
	sprintf(query,"SELECT %s FROM tMailServer WHERE uOwner=%u ORDER BY uMailServer",
					VAR_LIST_tMailServer,uLoginClient);

}//void ExttMailServerSelect(void)


void ExttMailServerSelectRow(void)
{
	if(uPermLevel<10)
                sprintf(query,"SELECT %s FROM tMailServer,tClient \
                                WHERE tMailServer.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)\
                                AND tMailServer.uMailServer=%u",
                        		VAR_LIST_tMailServer,
					uLoginClient,uLoginClient,uMailServer);
	else
                sprintf(query,"SELECT %s FROM tMailServer WHERE uMailServer=%u",
			VAR_LIST_tMailServer,uMailServer);

}//void ExttMailServerSelectRow(void)


void ExttMailServerListSelect(void)
{
	char cCat[512];

	if(uPermLevel<10)
		sprintf(query,"SELECT %s FROM tMailServer,tClient \
		WHERE tMailServer.uOwner=tClient.uClient \
		AND (tClient.uOwner=%u OR tClient.uClient=%u)",
				VAR_LIST_tMailServer,
				uLoginClient,
				uLoginClient);
	else
                sprintf(query,"SELECT %s FROM tMailServer",
				VAR_LIST_tMailServer);

	//Changes here must be reflected below in ExttMailServerListFilter()
        if(!strcmp(filter,"uMailServer"))
        {
                sscanf(command,"%u",&uMailServer);
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tMailServer.uMailServer=%u \
						ORDER BY uMailServer",
						uMailServer);
		strcat(query,cCat);
        }
        else if(1)
        {
                //None NO FILTER
                strcpy(filter,"None");
		strcat(query," ORDER BY uMailServer");
        }

}//void ExttMailServerListSelect(void)


void ExttMailServerListFilter(void)
{
        //Filter
        printf("<td align=right >Select ");
        printf("<select name=filter>");
        if(strcmp(filter,"uMailServer"))
                printf("<option>uMailServer</option>");
        else
                printf("<option selected>uMailServer</option>");
        if(strcmp(filter,"None"))
                printf("<option>None</option>");
        else
                printf("<option selected>None</option>");
        printf("</select>");

}//void ExttMailServerListFilter(void)


void ExttMailServerNavBar(void)
{
	if(uOwner) GetClientOwner(uOwner,&uReseller);

	printf(LANG_NBB_SKIPFIRST);
	printf(LANG_NBB_SKIPBACK);
	printf(LANG_NBB_SEARCH);

	if(uPermLevel>=10)
		printf(LANG_NBB_NEW);

	if( (uPermLevel>=10 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_MODIFY);

	if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_DELETE);

	printf(LANG_NBB_LIST);

	printf(LANG_NBB_SKIPNEXT);
	printf(LANG_NBB_SKIPLAST);

}//void ExttMailServerNavBar(void)


void tMailServerNavList(void)
{
        MYSQL_RES *res;
        MYSQL_ROW field;
	register unsigned uCount=0;

	if(uPermLevel<10)
		sprintf(query,"SELECT tMailServer.uMailServer\
				,tMailServer.cLabel\
				FROM tMailServer,tClient\
                                WHERE tMailServer.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u) LIMIT 101",
					uLoginClient,uLoginClient);
	else
	        sprintf(query,"SELECT uMailServer,cLabel FROM tMailServer LIMIT 101");

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
	        printf("<p><u>tMailServerNavList</u><br>\n");
                printf("%s",mysql_error(&mysql));
                return;
        }

        res=mysql_store_result(&mysql);
	if(mysql_num_rows(res))
	{
	        printf("<p><u>tMailServerNavList</u><br>\n");
	        while((field=mysql_fetch_row(res)))
	        {
	                printf("<a class=darkLink href=mysqlBind.cgi?function=tMailServer&uMailServer=%s>%s</a><br>\n",field[0],field[1]);
			uCount++;
	        }
		if(uCount>100)
			printf("More than 100 found. Showing only 101<br>\n");
	}
        mysql_free_result(res);

}//void tMailServerNavList(void)


// vim:tw=78
