/*
FILE
	tRRType source code of mysqlBind.cgi
	(built by mysqlRAD2.cgi (c) Gary Wallis 2001,2002 GPL Licensed)
	$Id: trrtype.c 53 2006-09-07 13:43:28Z root $
	(tAuthorize.cPasswd template set member)
PURPOSE
*/

#include "mysqlrad.h"

//Table Variables
//uRRType: Primary Key
static unsigned uRRType=0;
//cLabel: Short label
static char cLabel[33]={""};
//uParam1: Requires parameter 1
static unsigned uParam1=0;
//uParam2: Requires parameter 2
static unsigned uParam2=0;
//cParam1Func: Input validation function
static char cParam1Func[33]={""};
//cParam2Func: Input validation function
static char cParam2Func[33]={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
#define ISM3FIELDS
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tRRType "tRRType.uRRType,tRRType.cLabel,tRRType.uParam1,tRRType.uParam2,tRRType.cParam1Func,tRRType.cParam2Func,tRRType.uOwner,tRRType.uCreatedBy,tRRType.uCreatedDate,tRRType.uModBy,tRRType.uModDate"

 //Local only
void Insert_tRRType(void);
void Update_tRRType(char *rowid);
int InsertUpdate_tRRType(char *cKey);
void ProcesstRRTypeListVars(pentry entries[], int x);

 //In tRRTypefunc.h file included below
void ExtProcesstRRTypeVars(pentry entries[], int x);
void ExttRRTypeCommands(pentry entries[], int x);
void ExttRRTypeButtons(void);
void ExttRRTypeNavBar(void);
void ExttRRTypeGetHook(entry gentries[], int x);
void ExttRRTypeSelect(void);
void ExttRRTypeSelectRow(void);
void ExttRRTypeListSelect(void);
void ExttRRTypeListFilter(void);
void ExttRRTypeAuxTable(void);

#include "trrtypefunc.h"

 //Table Variables Assignment Function
void ProcesstRRTypeVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uRRType"))
			sscanf(entries[i].val,"%u",&uRRType);
		else if(!strcmp(entries[i].name,"cLabel"))
			sprintf(cLabel,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"uParam1"))
			sscanf(entries[i].val,"%u",&uParam1);
		else if(!strcmp(entries[i].name,"uParam2"))
			sscanf(entries[i].val,"%u",&uParam2);
		else if(!strcmp(entries[i].name,"cParam1Func"))
			sprintf(cParam1Func,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"cParam2Func"))
			sprintf(cParam2Func,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//After so we can overwrite form data if needed.
	ExtProcesstRRTypeVars(entries,x);

}//ProcesstRRTypeVars()


void ProcesstRRTypeListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uRRType);
                        mode=6;
                        tRRType("");
                }
        }
}//void ProcesstRRTypeListVars(pentry entries[], int x)


int tRRTypeCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttRRTypeCommands(entries,x);

	if(!strcmp(function,"tRRTypeTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tRRTypeList();
		}

		//Default
		ProcesstRRTypeVars(entries,x);
		tRRType("");
	}
	else if(!strcmp(function,"tRRTypeList"))
	{
		ProcessControlVars(entries,x);
		ProcesstRRTypeListVars(entries,x);
		tRRTypeList();
	}

	return(0);

}//tRRTypeCommands()


void tRRType(const char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttRRTypeSelectRow();
		else
			ExttRRTypeSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetRRType();
				mysqlBind("New tRRType table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tRRType WHERE uRRType=%u"
						,uRRType);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
		sscanf(field[0],"%u",&uRRType);
		sprintf(cLabel,"%.32s",field[1]);
		sscanf(field[2],"%u",&uParam1);
		sscanf(field[3],"%u",&uParam2);
		sprintf(cParam1Func,"%.32s",field[4]);
		sprintf(cParam2Func,"%.32s",field[5]);
		sscanf(field[6],"%u",&uOwner);
		sscanf(field[7],"%u",&uCreatedBy);
		sscanf(field[8],"%lu",&uCreatedDate);
		sscanf(field[9],"%u",&uModBy);
		sscanf(field[10],"%lu",&uModDate);

		}

	}//Internal Skip

	Header_ism3(":: tRRType",0);
	printf("<form action=mysqlBind.cgi method=post >\n");
	printf("<table width=100%% border=0 cellspacing=0 cellpadding=0>\n");
	printf("<tr><td colspan=2 align=right valign=center>");


	printf("<input type=hidden name=function value=tRRTypeTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf(" <b> %s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top width=25%%>");

        ExttRRTypeButtons();

        printf("</td><td valign=top>");

	OpenFieldSet("Record Data",100);
	if(mode==2000 || mode==2002)
		tRRTypeInput(1);
	else
		tRRTypeInput(0);

	CloseFieldSet();
	
	Footer_ism3();

}//end of tRRType();


void tRRTypeInput(unsigned uMode)
{
	//uRRType
	OpenRow(LANG_FL_tRRType_uRRType,"black");
	printf("<input title='%s' type=text name=uRRType value=%u size=16 maxlength=10 ",LANG_FT_tRRType_uRRType,uRRType);
	if(uPermLevel>=20 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uRRType value=%u >\n",uRRType);
	}
	//cLabel
	OpenRow(LANG_FL_tRRType_cLabel,"black");
	printf("<input title='%s' type=text name=cLabel value=\"%s\" size=40 maxlength=32 ",LANG_FT_tRRType_cLabel,EncodeDoubleQuotes(cLabel));
	if(uPermLevel>=8 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cLabel value=\"%s\">\n",
			EncodeDoubleQuotes(cLabel));			
	}
	//uParam1
	OpenRow(LANG_FL_tRRType_uParam1,"black");
	printf("<input title='%s' type=text name=uParam1 value=%u size=16 maxlength=10 ",LANG_FT_tRRType_uParam1,uParam1);
	if(uPermLevel>=8 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uParam1 value=%u>\n",uParam1);
	}
	//uParam2
	OpenRow(LANG_FL_tRRType_uParam2,"black");
	printf("<input title='%s' type=text name=uParam2 value=%u size=16 maxlength=10 ",LANG_FT_tRRType_uParam2,uParam2);
	if(uPermLevel>=8 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uParam2 value=%u>\n",uParam2);
	}
	//cParam1Func
	OpenRow(LANG_FL_tRRType_cParam1Func,"black");
	printf("<input title='%s' type=text name=cParam1Func value=\"%s\" size=40 maxlength=32 ",LANG_FT_tRRType_cParam1Func,
		EncodeDoubleQuotes(cParam1Func));
	if(uPermLevel>=8 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cParam1Func value=\"%s\">\n",EncodeDoubleQuotes(cParam1Func));
	}
	//cParam2Func
	OpenRow(LANG_FL_tRRType_cParam2Func,"black");
	printf("<input title='%s' type=text name=cParam2Func value=\"%s\" size=40 maxlength=32 ",LANG_FT_tRRType_cParam2Func,
		EncodeDoubleQuotes(cParam2Func));
	if(uPermLevel>=8 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cParam2Func value=\"%s\">\n",EncodeDoubleQuotes(cParam2Func));
	}
	//uOwner
	OpenRow(LANG_FL_tRRType_uOwner,"black");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	//uCreatedBy
	OpenRow(LANG_FL_tRRType_uCreatedBy,"black");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	//uCreatedDate
	OpenRow(LANG_FL_tRRType_uCreatedDate,"black");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	//uModBy
	OpenRow(LANG_FL_tRRType_uModBy,"black");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	//uModDate
	OpenRow(LANG_FL_tRRType_uModDate,"black");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");



}//void tRRTypeInput(unsigned uMode)


void NewtRRType(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uRRType FROM tRRType\
				WHERE uRRType=%u"
							,uRRType);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tRRType("<blink>Record already exists");
		tRRType(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tRRType();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uRRType=mysql_insert_id(&mysql);

	if(!uMode)
	{
	sprintf(query,LANG_NBR_NEWRECADDED,uRRType);
	tRRType(query);
	}

}//NewtRRType(unsigned uMode)


void DeletetRRType(void)
{
#ifdef ISM3FIELDS
	sprintf(query,"DELETE FROM tRRType WHERE uRRType=%u AND ( uOwner=%u OR %u>9 )"
					,uRRType,uLoginClient,uPermLevel);
#else
	sprintf(query,"DELETE FROM tRRType WHERE uRRType=%u"
					,uRRType);
#endif
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tRRType("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tRRType(LANG_NBR_RECDELETED);
	else
		tRRType(LANG_NBR_RECNOTDELETED);

}//void DeletetRRType(void)


void Insert_tRRType(void)
{

#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//insert query

	//insert query
	sprintf(query,"INSERT INTO tRRType SET  uRRType=%u, cLabel='%s', uParam1=%u, uParam2=%u, cParam1Func='%s', cParam2Func='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uRRType
			,TextAreaSave(cLabel)
			,uParam1
			,uParam2
			,TextAreaSave(cParam1Func)
			,TextAreaSave(cParam2Func)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
#ifdef ISM3FIELDS
	uCreatedDate=clock;
#endif

}//void Insert_tRRType(void)


void Update_tRRType(char *rowid)
{
#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//update query

	//update query
	sprintf(query,"UPDATE tRRType SET uRRType=%u,cLabel='%s',uParam1=%u,uParam2=%u,cParam1Func='%s',cParam2Func='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uRRType
			,TextAreaSave(cLabel)
			,uParam1
			,uParam2
			,TextAreaSave(cParam1Func)
			,TextAreaSave(cParam2Func)
			,uModBy
			,(long unsigned)clock
			,rowid);


	mysql_query(&mysql,query);

#ifdef ISM3FIELDS
	uModDate=clock;
#endif

}//void Update_tRRType(void)


void ModtRRType(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
#ifdef ISM3FIELDS
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tRRType.uRRType,\
				tRRType.uModDate\
				FROM tRRType,tClient\
				WHERE tRRType.uRRType=%u\
				AND tRRType.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uRRType,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uRRType,uModDate FROM tRRType\
				WHERE uRRType=%u"
						,uRRType);
#else
	sprintf(query,"SELECT uRRType FROM tRRType\
				WHERE uRRType=%u"
						,uRRType);
#endif

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tRRType("<blink>Record does not exist");
	if(i<1) tRRType(LANG_NBR_RECNOTEXIST);
	//if(i>1) tRRType("<blink>Multiple rows!");
	if(i>1) tRRType(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
#ifdef ISM3FIELDS
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tRRType(LANG_NBR_EXTMOD);
#endif

	Update_tRRType(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tRRType(query);

}//ModtRRType(void)


void tRRTypeList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttRRTypeListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tRRTypeList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttRRTypeListFilter();

	printf("<input type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=100%%>\n");
	printf("<tr bgcolor=black><td><font color=white>uRRType<td><font color=white>cLabel<td><font color=white>uParam1<td><font color=white>uParam2<td><font  color=white>cParam1Func<td><font color=white>cParam2Func<td><font color=white>uOwner<td><font color=white>uCreatedBy<td><font color=white>uCreatedDate<td><font color=white>uModBy<td><font color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
                long unsigned luTime10=strtoul(field[10],NULL,10);
                char cBuf10[32];
                if(luTime10)
                        ctime_r(&luTime10,cBuf10);
                else
                       sprintf(cBuf10,"---");
                long unsigned luTime8=strtoul(field[8],NULL,10);
                char cBuf8[32];
                if(luTime8)
                        ctime_r(&luTime8,cBuf8);
                else
                       sprintf(cBuf8,"---");
													       
		printf("<td><input type=submit name=ED%s value=Edit> %s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,field[2]
			,field[3]
			,field[4]
			,field[5]
			,ForeignKey("tClient","cLabel",strtoul(field[6],NULL,10))
			,ForeignKey("tClient","cLabel",strtoul(field[7],NULL,10))
			,cBuf8
			,ForeignKey("tClient","cLabel",strtoul(field[9],NULL,10))
			,cBuf10
				);

	}

	printf("</table></form>\n");
	
	Footer_ism3();

}//tRRTypeList()


void CreatetRRType(void)
{
	sprintf(query,"CREATE TABLE tRRType ( uRRType int unsigned NOT NULL PRIMARY KEY AUTO_INCREMENT, cLabel varchar(32) NOT NULL DEFAULT '', UNIQUE (cLabel), uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, uParam1 int unsigned NOT NULL DEFAULT 0, uParam2 int unsigned NOT NULL DEFAULT 0, cParam2Func varchar(32) NOT NULL DEFAULT '', cParam1Func varchar(32) NOT NULL DEFAULT '' )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetRRType()

