// $Id: language.h 55 2006-09-07 16:32:59Z root $
// English: USA
// Navigation bar buttons and results

#define LANG_NB_LIST "List"
#define LANG_NB_MODIFY "Modify"
#define LANG_NB_CONFIRMMOD "Confirm Modify"
#define LANG_NB_NEW "New"
#define LANG_NB_DELETE "Delete"
#define LANG_NB_CONFIRMNEW "Create New Record"
#define LANG_NBB_CONFIRMNEW "<input class=lrevButton title='Double check!' type=submit name=command value=\"Create New Record\">"
#define LANG_NB_CONFIRMDEL "Confirm Delete"
#define LANG_NBB_CONFIRMDEL "<input class=lwarnButton title='No undo available!' type=submit name=command value=\"Confirm Delete\">"
#define LANG_NBB_CONFIRMMOD "<input class=lalertButton title='Double check!' type=submit name=command value=\"Confirm Modify\">"


#define LANG_NBR_FOUND " Found"
#define LANG_NBR_MODIFIED " Modified"
#define LANG_NBR_NEW " New"
#define LANG_NBR_NORECS " No records found"
#define LANG_NBRF_SHOWING " (Showing %lu of %d)"

#define LANG_NBR_RECEXISTS "<blink>Record already exists"
#define LANG_NBR_NEWRECADDED "New record %u added"
#define LANG_NBR_RECDELETED "Record Deleted"
#define LANG_NBR_RECNOTDELETED "Record Not Deleted"
#define LANG_NBR_RECNOTEXIST "<blink>Record does not exist"
#define LANG_NBR_MULTRECS "<blink>Multiple rows!"
#define LANG_NBR_EXTMOD "<blink>This record was just modified by another user!"
#define LANG_NBRF_REC_MODIFIED "record %s modified"

#define LANG_NBB_SKIPFIRST "<input style='width:30px;' title=\"Skip to first record\" type=submit name=find value=\"<<\" >"
#define LANG_NBB_SKIPBACK "<input style='width:30px;' title=\"Go back one record\" type=submit name=find value=\"< \" >"
#define LANG_NBB_SKIPNEXT "<input style='width:30px;' title=\"Advance to next record\" type=submit name=find value=\" >\" >"
#define LANG_NBB_SKIPLAST "<input style='width:30px;' title=\"Skip to last record\" type=submit name=find value=\">>\" >\n&nbsp;&nbsp;&nbsp;"

//Modified for local .h use
#define LANG_NBB_NEWREV "<input class=revButton title=\"Create new record\" type=submit name=command value=New>"
#define LANG_NBB_NEW "<input  title=\"Create new record\" type=submit name=command value=New>"
#define LANG_NBB_DELETE "<input class=warnButton title=\"Delete current record\" type=submit name=command value=Delete>"
#define LANG_NBB_MODIFY "<input class=alertButton title=\"Modify current record\" type=submit name=command value=Modify>"

#define LANG_NBB_LIST "<input title=\"Paginated listing of all records\" type=submit name=find value=List>"
#define LANG_NBB_SEARCH "<input class=revButton title=\"Find record with parameters set below\" type=submit name=find value=Search>"

#define LANG_PAGEMACHINE_HINT "No matching records found.<br>"
#define LANG_PAGEMACHINE_SHOWING "Page %d/%d (Records %d-%d of %d)\n"
#define LANG_PAGEMACHINE_SEARCH "<input type=submit name=find value=Search >"
#define LANG_PAGEMACHINE_SEARCHBUTTON "Search"

//tZone
#define LANG_FL_tZone_uZone "uZone"
#define LANG_FT_tZone_uZone "Primary Key"
#define LANG_FL_tZone_cZone "cZone"
#define LANG_FT_tZone_cZone "Fully qualified zone name"
#define LANG_FL_tZone_uNameServer "uNameServer"
#define LANG_FT_tZone_uNameServer "Group of name servers"
#define LANG_FL_tZone_cHostmaster "cHostmaster"
#define LANG_FT_tZone_cHostmaster "eMail address of responsible person of this zone"
#define LANG_FL_tZone_uSerial "uSerial"
#define LANG_FT_tZone_uSerial "Zone serial number"
#define LANG_FL_tZone_uExpire "uExpire"
#define LANG_FT_tZone_uExpire "Slave server expiration time"
#define LANG_FL_tZone_uRefresh "uRefresh"
#define LANG_FT_tZone_uRefresh "Slave server refresh time"
#define LANG_FL_tZone_uTTL "uTTL"
#define LANG_FT_tZone_uTTL "SOA time to live"
#define LANG_FL_tZone_uRetry "uRetry"
#define LANG_FT_tZone_uRetry "Slave server retry interval after uRefresh"
#define LANG_FL_tZone_uZoneTTL "uZoneTTL"
#define LANG_FT_tZone_uZoneTTL "Used for negative caching. Technically default TTL minimum seconds"
#define LANG_FL_tZone_uMailServers "uMailServers"
#define LANG_FT_tZone_uMailServers "Group of mail servers"
#define LANG_FL_tZone_cMainAddress "cMainAddress"
#define LANG_FT_tZone_cMainAddress "Main A Record. Not required for some zones."
#define LANG_FL_tZone_uOwner "uOwner"
#define LANG_FT_tZone_uOwner "Record owner"
#define LANG_FL_tZone_uCreatedBy "uCreatedBy"
#define LANG_FT_tZone_uCreatedBy "uClient for last insert"
#define LANG_FL_tZone_uCreatedDate "uCreatedDate"
#define LANG_FT_tZone_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tZone_uModBy "uModBy"
#define LANG_FT_tZone_uModBy "uClient for last update"
#define LANG_FL_tZone_uModDate "uModDate"
#define LANG_FT_tZone_uModDate "Unix seconds date last update"
#define LANG_BL_TableAddRR "Add Resource Record"
#define LANG_BT_TableAddRR "Add resource record to this zone"
//tResource
#define LANG_FL_tResource_uResource "uResource"
#define LANG_FT_tResource_uResource "Primary Key"
#define LANG_FL_tResource_uZone "uZone"
#define LANG_FT_tResource_uZone "Belongs to this tZone"
#define LANG_FL_tResource_cName "cName"
#define LANG_FT_tResource_cName "Host name"
#define LANG_FL_tResource_uTTL "uTTL"
#define LANG_FT_tResource_uTTL "Resource record TTL in seconds"
#define LANG_FL_tResource_uRRType "uRRType"
#define LANG_FT_tResource_uRRType "Resource record type"
#define LANG_FL_tResource_cParam1 "cParam1"
#define LANG_FT_tResource_cParam1 "Parameter 1 of resource record"
#define LANG_FL_tResource_cParam2 "cParam2"
#define LANG_FT_tResource_cParam2 "Parameter 2 of resource record"
#define LANG_FL_tResource_cComment "cComment"
#define LANG_FT_tResource_cComment "Resource record comment"
#define LANG_FL_tResource_uOwner "uOwner"
#define LANG_FT_tResource_uOwner "Record owner"
#define LANG_FL_tResource_uCreatedBy "uCreatedBy"
#define LANG_FT_tResource_uCreatedBy "uClient for last insert"
#define LANG_FL_tResource_uCreatedDate "uCreatedDate"
#define LANG_FT_tResource_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tResource_uModBy "uModBy"
#define LANG_FT_tResource_uModBy "uClient for last update"
#define LANG_FL_tResource_uModDate "uModDate"
#define LANG_FT_tResource_uModDate "Unix seconds date last update"
//tRRType
#define LANG_FL_tRRType_uRRType "uRRType"
#define LANG_FT_tRRType_uRRType "Primary Key"
#define LANG_FL_tRRType_cLabel "cLabel"
#define LANG_FT_tRRType_cLabel "Short label"
#define LANG_FL_tRRType_uParam1 "uParam1"
#define LANG_FT_tRRType_uParam1 "Requires parameter 1"
#define LANG_FL_tRRType_uParam2 "uParam2"
#define LANG_FT_tRRType_uParam2 "Requires parameter 2"
#define LANG_FL_tRRType_cParam1Func "cParam1Func"
#define LANG_FT_tRRType_cParam1Func "Input validation function"
#define LANG_FL_tRRType_cParam2Func "cParam2Func"
#define LANG_FT_tRRType_cParam2Func "Input validation function"
#define LANG_FL_tRRType_uOwner "uOwner"
#define LANG_FT_tRRType_uOwner "Record owner"
#define LANG_FL_tRRType_uCreatedBy "uCreatedBy"
#define LANG_FT_tRRType_uCreatedBy "uClient for last insert"
#define LANG_FL_tRRType_uCreatedDate "uCreatedDate"
#define LANG_FT_tRRType_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tRRType_uModBy "uModBy"
#define LANG_FT_tRRType_uModBy "uClient for last update"
#define LANG_FL_tRRType_uModDate "uModDate"
#define LANG_FT_tRRType_uModDate "Unix seconds date last update"
//tJob
#define LANG_FL_tJob_uJob "uJob"
#define LANG_FT_tJob_uJob "Unique job ID"
#define LANG_FL_tJob_uMasterJob "uMasterJob"
#define LANG_FT_tJob_uMasterJob "Unique group job ID"
#define LANG_FL_tJob_cJob "cJob"
#define LANG_FT_tJob_cJob "Job command"
#define LANG_FL_tJob_cZone "cZone"
#define LANG_FT_tJob_cZone "Command argument usually a zone"
#define LANG_FL_tJob_uNameServer "uNameServer"
#define LANG_FT_tJob_uNameServer "Job assigned to these name servers"
#define LANG_FL_tJob_cTargetServer "cTargetServer"
#define LANG_FT_tJob_cTargetServer "Job assigned to this name servers"
#define LANG_FL_tJob_uPriority "uPriority"
#define LANG_FT_tJob_uPriority "Job priority"
#define LANG_FL_tJob_uTime "uTime"
#define LANG_FT_tJob_uTime "Unix date and time for job to start"
#define LANG_FL_tJob_cJobData "cJobData"
#define LANG_FT_tJob_cJobData "Aux job data"
#define LANG_FL_tJob_uOwner "uOwner"
#define LANG_FT_tJob_uOwner "Record owner"
#define LANG_FL_tJob_uCreatedBy "uCreatedBy"
#define LANG_FT_tJob_uCreatedBy "uClient for last insert"
#define LANG_FL_tJob_uCreatedDate "uCreatedDate"
#define LANG_FT_tJob_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tJob_uModBy "uModBy"
#define LANG_FT_tJob_uModBy "uClient for last update"
#define LANG_FL_tJob_uModDate "uModDate"
#define LANG_FT_tJob_uModDate "Unix seconds date last update"
//tNameServer
#define LANG_FL_tNameServer_uNameServer "uNameServer"
#define LANG_FT_tNameServer_uNameServer "Primary Key"
#define LANG_FL_tNameServer_cLabel "cLabel"
#define LANG_FT_tNameServer_cLabel "Group of name servers"
#define LANG_FL_tNameServer_cList "cList"
#define LANG_FT_tNameServer_cList "List of name servers"
#define LANG_FL_tNameServer_uOwner "uOwner"
#define LANG_FT_tNameServer_uOwner "Record owner"
#define LANG_FL_tNameServer_uCreatedBy "uCreatedBy"
#define LANG_FT_tNameServer_uCreatedBy "uClient for last insert"
#define LANG_FL_tNameServer_uCreatedDate "uCreatedDate"
#define LANG_FT_tNameServer_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tNameServer_uModBy "uModBy"
#define LANG_FT_tNameServer_uModBy "uClient for last update"
#define LANG_FL_tNameServer_uModDate "uModDate"
#define LANG_FT_tNameServer_uModDate "Unix seconds date last update"
//tMailServer
#define LANG_FL_tMailServer_uMailServer "uMailServer"
#define LANG_FT_tMailServer_uMailServer "Primary Key"
#define LANG_FL_tMailServer_cLabel "cLabel"
#define LANG_FT_tMailServer_cLabel "Group of mail servers"
#define LANG_FL_tMailServer_cList "cList"
#define LANG_FT_tMailServer_cList "List of mail servers"
#define LANG_FL_tMailServer_uOwner "uOwner"
#define LANG_FT_tMailServer_uOwner "Record owner"
#define LANG_FL_tMailServer_uCreatedBy "uCreatedBy"
#define LANG_FT_tMailServer_uCreatedBy "uClient for last insert"
#define LANG_FL_tMailServer_uCreatedDate "uCreatedDate"
#define LANG_FT_tMailServer_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tMailServer_uModBy "uModBy"
#define LANG_FT_tMailServer_uModBy "uClient for last update"
#define LANG_FL_tMailServer_uModDate "uModDate"
#define LANG_FT_tMailServer_uModDate "Unix seconds date last update"
//tConfiguration
#define LANG_FL_tConfiguration_uConfiguration "uConfiguration"
#define LANG_FT_tConfiguration_uConfiguration "Primary Key"
#define LANG_FL_tConfiguration_cLabel "cLabel"
#define LANG_FT_tConfiguration_cLabel "Short label"
#define LANG_FL_tConfiguration_cValue "cValue"
#define LANG_FT_tConfiguration_cValue "Value of name(cLabel)/value pair"
#define LANG_FL_tConfiguration_cComment "cComment"
#define LANG_FT_tConfiguration_cComment "Comment about this configuration name/value pair"
#define LANG_FL_tConfiguration_uOwner "uOwner"
#define LANG_FT_tConfiguration_uOwner "Record owner"
#define LANG_FL_tConfiguration_uCreatedBy "uCreatedBy"
#define LANG_FT_tConfiguration_uCreatedBy "uClient for last insert"
#define LANG_FL_tConfiguration_uCreatedDate "uCreatedDate"
#define LANG_FT_tConfiguration_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tConfiguration_uModBy "uModBy"
#define LANG_FT_tConfiguration_uModBy "uClient for last update"
#define LANG_FL_tConfiguration_uModDate "uModDate"
#define LANG_FT_tConfiguration_uModDate "Unix seconds date last update"
//tClient
#define LANG_FL_tClient_uClient "uClient"
#define LANG_FT_tClient_uClient "Primary Key"
#define LANG_FL_tClient_cLabel "cLabel"
#define LANG_FT_tClient_cLabel "Short label"
#define LANG_FL_tClient_cInfo "cInfo"
#define LANG_FT_tClient_cInfo "Unformatted info/address etc."
#define LANG_FL_tClient_uOwner "uOwner"
#define LANG_FT_tClient_uOwner "Record owner"
#define LANG_FL_tClient_uCreatedBy "uCreatedBy"
#define LANG_FT_tClient_uCreatedBy "uClient for last insert"
#define LANG_FL_tClient_uCreatedDate "uCreatedDate"
#define LANG_FT_tClient_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tClient_uModBy "uModBy"
#define LANG_FT_tClient_uModBy "uClient for last update"
#define LANG_FL_tClient_uModDate "uModDate"
#define LANG_FT_tClient_uModDate "Unix seconds date last update"
//tAuthorize
#define LANG_FL_tAuthorize_uAuthorize "uAuthorize"
#define LANG_FT_tAuthorize_uAuthorize "Primary Key"
#define LANG_FL_tAuthorize_cLabel "cLabel"
#define LANG_FT_tAuthorize_cLabel "Short label"
#define LANG_FL_tAuthorize_cIpMask "cIpMask"
#define LANG_FT_tAuthorize_cIpMask "Allow user from this IP"
#define LANG_FL_tAuthorize_uPerm "uPerm"
#define LANG_FT_tAuthorize_uPerm "User permission level"
#define LANG_FL_tAuthorize_uCertClient "uCertClient"
#define LANG_FT_tAuthorize_uCertClient "User uClient"
#define LANG_FL_tAuthorize_cPasswd "cPasswd"
#define LANG_FT_tAuthorize_cPasswd "Encrypted cgi login password"
#define LANG_FL_tAuthorize_uOwner "uOwner"
#define LANG_FT_tAuthorize_uOwner "Record owner"
#define LANG_FL_tAuthorize_uCreatedBy "uCreatedBy"
#define LANG_FT_tAuthorize_uCreatedBy "uClient for last insert"
#define LANG_FL_tAuthorize_uCreatedDate "uCreatedDate"
#define LANG_FT_tAuthorize_uCreatedDate "Unix seconds date last insert"
#define LANG_FL_tAuthorize_uModBy "uModBy"
#define LANG_FT_tAuthorize_uModBy "uClient for last update"
#define LANG_FL_tAuthorize_uModDate "uModDate"
#define LANG_FT_tAuthorize_uModDate "Unix seconds date last update"
