/*
FILE
        $Id: local.h 59 2006-09-11 14:41:43Z ggw $
PURPOSE
        Localization constants
LEGAL
        Copyright 2002-2004 Gary Wallis
	GPL license applies (see www.fsf.org for more info.)
	License included with this distribution.
*/

//Set to enable same directory as cgi "mysqlbind.conf" file
//Note that this may slow down the cgi a tad on some older servers.
//Make sure ownership and permissions are set correctly for security
//and webconsole httpd access.
//#define USECONF "mysqlBind.conf"

//.conf file format
//one configuration parameter per line in
//NAME=VALUE style fashion
//Available parameters:
//
//gcDbIp=192.168.0.23
//gcDbName=mysqlbind
//gcDbLogin=mysqlbind
//gcDbPasswd=wsxedc
//For experts only:
//guDbPort=0
//gcDbSocket=/var/lib/mysql/mysql4.sock
//
//Lines starting with # are ignored.
//Keep this file as small as possible.
//Do not use gcDbIP if you want it NULL for local mysql socket
//See sample mysqlBind.conf file in this dir.

//Set these up to match your mySQL database settings and location
//NULL is for stream socket on local server. Much faster than localhost tcp/ip.
#define DBIP NULL
#define DBNAME "mysqlbind"
#define DBLOGIN "mysqlbind"
#define DBPASSWD "wsxedc"
#define DBPORT 0
#define DBSOCKET NULL
//Example for host running two mysqld
//See makefile and mysqlrad.h CustomExample sections
//#define DBPORT 4306
//#define DBSOCKET "/var/lib/mysql/mysql4.sock"

//If you have Apache/mod_ssl uncomment below much better unless intranet
//ultra firewalled and secured.
//#define SSLONLY

//Set to your ISP name if you like
#define EXTISPNAME "openisp.net"
#define EXTISPURL "openisp.net"

//mysqlBind can report to us once a week some useful for
//debugging and development statistics.
//This is very useful to us and yourself for improving
//and developing this software
//On any mysql_error will send us the problem so we can fix it.
//#define DEBUG_REPORT_STATS_OFF

//When not using BIND 9 comment below and make clean, make, make install
#define BIND9

//If you would like to use your native language edit language.h or if 
//appropiate language2.h. cp it to language.h and recompile. This only covers 
//60-70% of language used. The rest can be changed in the .h schema independent 
//table related files.


//For openisp staff mod only. Staff: Remember to change makefile also.
#define RELEASE "1.94"
#define REL "1.94"
