/*
FILE
	tClient source code of mysqlBind.cgi
	(built by mysqlRAD2.cgi (c) Gary Wallis 2001,2002 GPL Licensed)
	$Id: tclient.c 40 2006-08-24 00:16:15Z hus $
	(tAuthorize.cPasswd template set member)
PURPOSE
*/

#include "mysqlrad.h"

//Table Variables
//uClient: Primary Key
static unsigned uClient=0;
//cLabel: Short label
static char cLabel[33]={""};
//cInfo: Unformatted info/address etc.
static char *cInfo={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
#define ISM3FIELDS
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tClient "tClient.uClient,tClient.cLabel,tClient.cInfo,tClient.uOwner,tClient.uCreatedBy,tClient.uCreatedDate,tClient.uModBy,tClient.uModDate"

 //Local only
void Insert_tClient(void);
void Update_tClient(char *rowid);
int InsertUpdate_tClient(char *cKey);
void ProcesstClientListVars(pentry entries[], int x);

 //In tClientfunc.h file included below
void ExtProcesstClientVars(pentry entries[], int x);
void ExttClientCommands(pentry entries[], int x);
void ExttClientButtons(void);
void ExttClientNavBar(void);
void ExttClientGetHook(entry gentries[], int x);
void ExttClientSelect(void);
void ExttClientSelectRow(void);
void ExttClientListSelect(void);
void ExttClientListFilter(void);
void ExttClientAuxTable(void);

#include "tclientfunc.h"

 //Table Variables Assignment Function
void ProcesstClientVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uClient"))
			sscanf(entries[i].val,"%u",&uClient);
		else if(!strcmp(entries[i].name,"cLabel"))
			sprintf(cLabel,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"cInfo"))
			cInfo=entries[i].val;
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//After so we can overwrite form data if needed.
	ExtProcesstClientVars(entries,x);

}//ProcesstClientVars()


void ProcesstClientListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uClient);
                        mode=6;
                        tClient("");
                }
        }
}//void ProcesstClientListVars(pentry entries[], int x)


int tClientCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttClientCommands(entries,x);

	if(!strcmp(function,"tClientTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tClientList();
		}

		//Default
		ProcesstClientVars(entries,x);
		tClient("");
	}
	else if(!strcmp(function,"tClientList"))
	{
		ProcessControlVars(entries,x);
		ProcesstClientListVars(entries,x);
		tClientList();
	}

	return(0);

}//tClientCommands()


void tClient(const char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttClientSelectRow();
		else
			ExttClientSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetClient();
				mysqlBind("New tClient table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tClient WHERE uClient=%u"
						,uClient);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
		sscanf(field[0],"%u",&uClient);
		sprintf(cLabel,"%.32s",field[1]);
		cInfo=field[2];
		sscanf(field[3],"%u",&uOwner);
		sscanf(field[4],"%u",&uCreatedBy);
		sscanf(field[5],"%lu",&uCreatedDate);
		sscanf(field[6],"%u",&uModBy);
		sscanf(field[7],"%lu",&uModDate);

		}

	}//Internal Skip

	Header_ism3(":: tClient",0);
/*	printf("<form action=mysqlBind.cgi method=post >\n");
	printf("<table width=100%% border=0 bgcolor=#A9BEC0 valign=center>\n");
	printf("<tr><td colspan=2><font face=Arial,Helvetica size=2>");
*/
        printf("<table width=100%% cellspacing=0 cellpadding=0>\n");
	printf("<tr><td colspan=2 align=right valign=center>");
		
	//ExttClientNavBar();

	printf("<input type=hidden name=function value=tClientTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
	//	printf(" <font color=blue >");
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf(" <b> %s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top width=25%%>");

	ExttClientButtons();

        printf("</td><td valign=top>");
	OpenFieldSet("Record Data",100);
//	printf("<table width=100%% border=0 bgcolor=#9BC1B3 valign=center>\n");

	if(mode==2000 || mode==2002)
		tClientInput(1);
	else
		tClientInput(0);

/*	printf("</table>\n");
	printf("</table>\n");*/
	CloseFieldSet();
	
	//Bottom table
//        ExttClientAuxTable();

//	printf("</font></form>\n");
	Footer_ism3();

}//end of tClient();


void tClientInput(unsigned uMode)
{

	//uClient
	OpenRow(LANG_FL_tClient_uClient,"black");
	printf("<input title='%s' type=text name=uClient value=%u size=16 maxlength=10 ",LANG_FT_tClient_uClient,uClient);	
	if(uPermLevel>=20)
		printf("></td></tr>\n");		
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uClient value=%u >\n",uClient);
	}

	//cLabel
	OpenRow(LANG_FL_tClient_cLabel,"black");
	printf("<input title='%s' type=text name=cLabel value=\"%s\" size=40 maxlength=32 ",LANG_FT_tClient_cLabel,EncodeDoubleQuotes(cLabel));
        if(uPermLevel>=8 && uMode)
	        printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cLabel value=\"%s\">\n",
			EncodeDoubleQuotes(cLabel));
	}
	
	OpenRow(LANG_FL_tClient_cInfo,"black");
	if(uPermLevel>=8 && uMode)	
		printf("<textarea title='%s' cols=60 wrap=hard rows=8 name=cInfo>%s</textarea>\n\n",LANG_FT_tClient_cInfo,cInfo);
	else
	{
		printf("<textarea title='%s' cols=60 wrap=hard rows=8 name=cInfo disabled>%s</textarea>\n\n",LANG_FT_tClient_cInfo,cInfo);
		printf("<input type=hidden name=cInfo value=\"%s\"",EncodeDoubleQuotes(cInfo));
	}
	OpenRow(LANG_FL_tClient_uOwner,"black");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	OpenRow(LANG_FL_tClient_uCreatedBy,"black");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	OpenRow(LANG_FL_tClient_uCreatedDate,"black");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	OpenRow(LANG_FL_tClient_uModBy,"black");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	OpenRow(LANG_FL_tClient_uModDate,"black");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");



}//void tClientInputContent(void)


void NewtClient(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uClient FROM tClient WHERE uClient=%u",uClient);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tClient("<blink>Record already exists");
		tClient(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tClient();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uClient=mysql_insert_id(&mysql);
	sprintf(query,LANG_NBR_NEWRECADDED,uClient);
	tClient(query);

}//NewtClient()


void DeletetClient(void)
{
	sprintf(query,"DELETE FROM tClient WHERE uClient=%u AND ( uOwner=%u OR %u>7 )"
					,uClient,uLoginClient,uPermLevel);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tClient("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tClient(LANG_NBR_RECDELETED);
	else
		tClient(LANG_NBR_RECNOTDELETED);

}//void DeletetClient(void)


void Insert_tClient(void)
{
	time_t clock;

        time(&clock);

	//insert query

	//insert query
	sprintf(query,"INSERT INTO tClient SET  uClient=%u, cLabel='%s', cInfo='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uClient
			,TextAreaSave(cLabel)
			,TextAreaSave(cInfo)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
	uCreatedDate=clock;

}//void Insert_tClient(void)


void Update_tClient(char *rowid)
{
	time_t clock;

        time(&clock);

	if(uPermLevel>10 && uOwner!=1)
	sprintf(query,"UPDATE tClient SET uClient=%u,cLabel='%s',cInfo='%s',uOwner=%u,uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uClient
			,TextAreaSave(cLabel)
			,TextAreaSave(cInfo)
			,uOwner
			,uModBy
			,(long unsigned)clock
			,rowid);
        else
        sprintf(query,"UPDATE tClient SET uClient=%u,cLabel='%s',cInfo='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uClient
			,TextAreaSave(cLabel)
			,TextAreaSave(cInfo)
			,uModBy
			,(long unsigned)clock
			,rowid);

	mysql_query(&mysql,query);

	uModDate=clock;

}//void Update_tClient(void)


void ModtClient(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tClient.uClient,\
				tClient.uModDate\
				FROM tClient\
				WHERE tClient.uClient=%u\
				AND tClient.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uClient,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uClient,uModDate FROM tClient\
				WHERE uClient=%u"
						,uClient);

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tClient("<blink>Record does not exist");
	if(i<1) tClient(LANG_NBR_RECNOTEXIST);
	//if(i>1) tClient("<blink>Multiple rows!");
	if(i>1) tClient(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tClient(LANG_NBR_EXTMOD);

	Update_tClient(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tClient(query);

}//ModtClient(void)


void tClientList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttClientListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tClientList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttClientListFilter();

	printf("<input type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=100%%>\n");
	printf("<tr bgcolor=black><td><font color=white>uClient<td><font color=white>cLabel<td><font color=white>cInfo<td><font color=white>uOwner<td><font color=white>uCreatedBy<td><font color=white>uCreatedDate<td><font color=white>uModBy<td><font color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
		long unsigned luTime5=strtoul(field[5],NULL,10);
		char cBuf5[32];
		if(luTime5)
		        ctime_r(&luTime5,cBuf5);
		else
			sprintf(cBuf5,"---");
		long unsigned luTime7=strtoul(field[7],NULL,10);
		char cBuf7[32];
		if(luTime7)
			ctime_r(&luTime7,cBuf7);
		else
			 sprintf(cBuf7,"---");

		printf("<td><input type=submit name=ED%s value=Edit> %s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,field[2]
			,ForeignKey("tClient","cLabel",strtoul(field[3],NULL,10))
			,ForeignKey("tClient","cLabel",strtoul(field[4],NULL,10))
			,cBuf5
			,ForeignKey("tClient","cLabel",strtoul(field[6],NULL,10))
			,cBuf7
				);

	}
	printf("</table></form>\n");

	Footer_ism3();

}//tClientList()


void CreatetClient(void)
{
	sprintf(query,"CREATE TABLE tClient ( uClient int unsigned NOT NULL PRIMARY KEY AUTO_INCREMENT, cLabel varchar(32) NOT NULL DEFAULT '', UNIQUE (cLabel), uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, cInfo text NOT NULL DEFAULT '' )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetClient()

